Bash functions style cleanup
[csit.git] / resources / libraries / bash / function / ansible.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2019 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -exuo pipefail
17
18
19 function ansible_hosts () {
20
21     # Run ansible playbook on hosts in working topology file. Ansible scope is
22     # determined by tags passed as parameters to this function.
23     #
24     # Variable read:
25     # - ${WORKING_TOPOLOGY} - Reserved working topology.
26     # - ${TOOLS_DIR} - CSIT tools directory, where testbed-setup is located.
27
28     set -exuo pipefail
29
30     if ! installed sshpass; then
31         sudo apt-get update -y || die "apt-get update failed!"
32         sudo apt-get install -y sshpass || die "Install sshpass failed!"
33     fi
34
35     if ! installed ansible-playbook; then
36         # TODO: Consider moving to requirements.txt?
37         pip install ansible==2.7.8 || die "Install ansible via PIP failed!"
38     fi
39
40     hosts=($(fgrep host "${WORKING_TOPOLOGY}" | cut -d ":" -f 2)) || {
41         die "Failed to read hosts from working topology!"
42     }
43     pushd "${TOOLS_DIR}"/testbed-setup/ansible || die "Pushd failed!"
44     ANSIBLE_STDOUT_CALLBACK=yaml ansible-playbook \
45         --vault-password-file=vault_pass \
46         --extra-vars '@vault.yml' \
47         --inventory inventories/lf_inventory/hosts site.yaml \
48         --limit "$(echo ${hosts[@]//\"})" \
49         --tags "$(echo $@)" || die "Failed to run ansible on host!"
50     popd || die "Popd failed!"
51 }
52
53 function installed () {
54
55     # Check if the given utility is installed. Fail if not installed.
56     #
57     # Arguments:
58     # - ${1} - Utility to check.
59     # Returns (implicitly):
60     # - 0 - If command is installed.
61     # - 1 - If command is not installed.
62
63     set -exuo pipefail
64
65     command -v "${1}"
66 }